from opcua import ua
import sys
import logging
import time
from opcua import Client
from opcua.common.node import Node
from opcua.ua.uatypes import EPOCH_AS_FILETIME

# you have to install the opcua package with the following commands
# apt install python3-dev
# sudo apt install python3-pip
# sudo pip3 install opcua cryptography


def getInteger(a, b):
    print('--Python function getInteger() called')
    c = a*b
    return c


# Define global heap_status_start, heap
global heap_status_start, heap
global connctedToClient


# def startRecordingState():
#     global heap_status_start, heap
#     heap = hpy()
#     heap_status_start = heap.heap()
#     return True


def connect(addr):
    client = Client(addr)
    try:
        client.connect()
        client.load_type_definitions()
        root = client.get_root_node()
        print("-- Children of root are: ", root.get_children())
    except Exception:
        print("-- could not connecnt to client")
        return False
    # finally:
    #     pass
    return client

    # finally:
    #     pass
    # print heap data:

    # heap_status_end = heap.heap()
    # stats = heap_status_end.diff(heap_status_start)

    # statsAsStr = "Whether Two Heap Status Are Disjoint : " + "\n" + \
    #     str(heap_status_start.disjoint(heap_status_end)) + "\n" +\
    #     "Total Objects : " + str(stats.count) + "\n" +\
    #     "Total Size : " + str(stats.size) + " Bytes" + "\n" +\
    #     "Number of Entries : " + str(stats.numrows) + "\n" +\
    #     "Entries : " + "\n" +\
    #     "Index    Count    Size    Cumulative Size       Object Name" + "\n"

    # for row in stats.get_rows():
    #     statsAsStr += str(row.index) + "\t" + str(row.count) + "\t" + \
    #         str(row.size) + "\t" + str(row.cumulsize) + \
    #         "\t" + str(row.name) + "\n"
    # return client


# def getHeapInfo():

#     # h = hpy()
#     # retVal = str(h.heap())
#     global heap, heap_status_start
#     heap2 = hpy()
#     currentHeapInfo = heap2.heap()

#     currentHeapInfoAsStr = "--current memory state" + str(currentHeapInfo)

#     stats = currentHeapInfo.diff(heap_status_start)
#     statsAsStr = "Whether Two Heap Status Are Disjoint : " + str(heap_status_start.disjoint(currentHeapInfo)) + "\n" +\
#         "Total Objects : " + str(stats.count) + "\n" +\
#         "Total Size : " + str(stats.size) + " Bytes" + "\n" +\
#         "Number of Entries : " + str(stats.numrows) + "\n" +\
#         "Entries : " + "\n" +\
#         "Index    Count    Size    Cumulative Size       Object Name" + "\n"
#     for row in stats.get_rows():
#         statsAsStr += str(row.index) + "\t" + str(row.count) + "\t" + \
#             str(row.size) + "\t" + str(row.cumulsize) + \
#             "\t" + str(row.name) + "\n"
#     return currentHeapInfoAsStr, statsAsStr
#     # return retVal


# def disConnect(client):
#     client.disconnect()
#     return True

def disConnect(client):
    try:
        client.disconnect()
    except:
        e = sys.exc_info()[0]
        print("--<p> could not disconnect() Error: %s</p>" % e)
        return False


def readNodes(client, NodesListIds):
    try:
        results = []
        for i in range(len(NodesListIds)):
            results.append(client.get_node(NodesListIds[i]).get_value())
        return [str(item) for item in results]
    except:
        e = sys.exc_info()[0]
        print("<p> --readNodes() Error: %s</p>" % e)
        return 0

# def readNodes(client, NodesListIds):
#     try:
#         myNodes = []
#         for i in range(len(NodesListIds)):
#             myNodes.append(Node(client,NodesListIds[i]))
#         results = client.get_values(myNodes)
#         # now = datetime.now().time() # time object
#         # print("now =", now)
#         return [str(item) for item in results ]
#         #return results
#     except:
#         e = sys.exc_info()[0]
#         print( "<p> --readNodes() Error: %s</p>" % e )
#         return 0


def getSinumerkNode(client):
    var = client.get_node("ns=2;s=Sinumerik")
    print("--var node is: ", var)
    return var


def getValOfNode(client, nodeId):
    node = client.get_node(nodeId)
    return node.get_value()


def getDataTypeOfNode(client, nodeId):
    node = client.get_node(nodeId)
    return node.get_data_type_as_variant_type().name


def getChildrenOfNode(client, nodeId):
    node = client.get_node(nodeId)
    return node.get_children()


def getValueAsFloat(client, nodeAddre):

    root = client.get_root_node()
    objNode = root.get_child("0:Objects")
    programNameObj = objNode.get_child(nodeAddre)
    programNameVal = programNameObj.get_value()
    return programNameVal


def getValueAsString(client, nodeAddre):

    root = client.get_root_node()
    objNode = root.get_child("0:Objects")
    programNameObj = objNode.get_child(nodeAddre)
    programNameVal = programNameObj.get_value()
    return programNameVal
